<?php

$rowStart = 4;

// echo '<meta charset="utf-8" />';
// echo '<pre>';
// print_r($staff);
// echo '</pre>';
// exit;

foreach ($staff as $s) {
	if(!isset($data[$s['name']])) $data[$s['name']] = array();
	$name = $s['name'];
	$person = $data[$s['name']];

	$rowNext  = $rowStart + 1;

	// 填姓名
	$objPHPExcel->getActiveSheet()->mergeCells('A'.$rowStart.':A'.$rowNext); // 合并姓名格
	$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, $name); // 填姓名

	// 填上午和下午
	$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '上午');
	$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowNext,  '下午');

	$lateCount = 0; // 迟到次数
	$noSignCount = 0; // 未打卡次数
	$leaveEarlyCount = 0; // 早退次数

	// 每天的考勤
	for($d = 1; $d <= $totalDay; $d++){

		$isMonday = 0;
		if(isset($person[$d])){ // 如果当天有数据
			if(in_array($d, $monday)) $isMonday = 1;
			$dayRs = getDayRs($person[$d],$isMonday,$s['dept'],$s['spec']); // 该天的打卡结果
			if(empty($dayRs['AM'])) $dayRs['AM'] = '休';
			if(empty($dayRs['PM'])) $dayRs['PM'] = '休';
		}else{
			$dayRs = array('AM'=>'休','PM'=>'休');
		}
		// 填数据
		$col = PHPExcel_Cell::stringFromColumnIndex($d+1); // 每从第3格开始填
		# 上午
		if('迟到' == $dayRs['AM']){
			$lateCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->applyFromArray($lateStyle);
		}else if('未签' == $dayRs['AM']){
			$noSignCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->applyFromArray($noSignStyle);
		}else if('未退' == $dayRs['AM']){
			$noSignCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->applyFromArray($noSignOffStyle);
		}else if('早退' == $dayRs['AM']){
			$leaveEarlyCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->applyFromArray($leaveEarlyStyle);
		}else if('迟到早退' == $dayRs['AM']){
			$lateCount++;
			$leaveEarlyCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->applyFromArray($lateStyle);
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowStart)->getFill()->getStartColor()->setARGB("FFFFCC99");
		}else{
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, $dayRs['AM']);
		}
		# 下午
		if('迟到' == $dayRs['PM']){
			$lateCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->applyFromArray($lateStyle);
		}else if('未签' == $dayRs['PM']){
			$noSignCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->applyFromArray($noSignStyle);
		}else if('未退' == $dayRs['PM']){
			$noSignCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->applyFromArray($noSignOffStyle);
		}else if('早退' == $dayRs['PM']){
			$leaveEarlyCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->applyFromArray($leaveEarlyStyle);
		}else if('迟到早退' == $dayRs['PM']){
			$lateCount++;
			$leaveEarlyCount++;
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, '√');
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->applyFromArray($lateStyle);
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
			$objPHPExcel->getActiveSheet()->getStyle($col.$rowNext)->getFill()->getStartColor()->setARGB("FFFFCC99");
		}else{
			$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext, $dayRs['PM']);
		}
	}

	// 考勤记录以外的数据
	# 迟到(分)：
	$val_0  = $lateCount > 0 ? $lateCount : '';
	# 早退：
	$val_1  = $leaveEarlyCount > 0 ? $leaveEarlyCount : '';
	# 旷工：
	$val_2  = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*旷*")/2';
	# 未打卡：
	$val_3  = $noSignCount > 0 ? $noSignCount : '';
	# 实际出勤：
	$val_4  = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"√")/2';
	# 事假：
	$val_5  = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*事*")/2';
	# 有薪假：
	$val_6  = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*薪*")/2';
	# 加班：
	$val_7  = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*班*")/2';
	# 上月累计休：
	$val_8  = isset($unRestDay[$name]) ? $unRestDay[$name] : '';
	# 本月应休：
	$val_9  = $saturdayCount*0.5+$sundayCount;
	# 本月实休：
	$val_10 = '=COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*休*")/2';
	# 本月补休：
	$val_11 = empty($s['name']) ? '' : (int)$s['days'];
	// $val_10 = '=(COUNTIF(C'.$rowStart.':'.$col.$rowNext.',"*休*")+COUNTBLANK(C'.$rowStart.':'.$col.$rowNext.'))/2';
	# 下月累计休：
	$col_1 = PHPExcel_Cell::stringFromColumnIndex(2+$totalDay+8);
	$col_2 = PHPExcel_Cell::stringFromColumnIndex(2+$totalDay+9);
	$col_3 = PHPExcel_Cell::stringFromColumnIndex(2+$totalDay+10);
	$col_4 = PHPExcel_Cell::stringFromColumnIndex(2+$totalDay+11);
	$val_12 = "={$col_1}{$rowStart}+{$col_2}{$rowStart}-{$col_3}{$rowStart}+{$col_4}{$rowStart}";
	// 合并单元格后填值
	$i = 0;
	for($d = 2+$totalDay; $d < 2+$totalDay+13; $d++){
		// 合并单元格
		$col = PHPExcel_Cell::stringFromColumnIndex($d);
		$objPHPExcel->getActiveSheet()->mergeCells($col.$rowStart.':'.$col.$rowNext);
		// 填值
		$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, ${'val_'.$i});
		$i++;
	}
	$rowStart += 2;
}

// 注释数据
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '正常：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
// $objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($noSignOffStyle);
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '迟到：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($lateStyle);
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '早退：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($leaveEarlyStyle);
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '迟到早退：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($lateStyle);
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->getFill()->getStartColor()->setARGB("FFFFCC99");
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '未签到：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($noSignStyle);
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '未签退：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '√');
$objPHPExcel->getActiveSheet()->getStyle('B'.$rowStart)->applyFromArray($noSignOffStyle);
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '未签未退：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '休');
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '未出勤：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '休');
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '事假：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '事');
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '有薪假：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '薪');
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '加班：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '班');
$rowStart++;
$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, '旷工：');
$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '旷');

// exit;
// goto output;

/**

 */
// tab1:
// goto tab2;
// 第二张表的内容（sheet02）
# thead 部分
$objPHPExcel->setActiveSheetIndex(1);
$objPHPExcel->getActiveSheet()->freezePane('C4'); // 冻结窗格

$day = 1;
$totalDay = date('t',$time); // 当月天数
$iBegin = PHPExcel_Cell::columnIndexFromString('A')-1;
$iEnd   = 2 + $totalDay -1;
$endCol = PHPExcel_Cell::stringFromColumnIndex($iEnd);
$week = explode(' ', '日 一 二 三 四 五 六');
$weekStart = date('w',strtotime(date('Y-m-1 01:00:00',$time)));
$saturdayCount = $sundayCount = 0;
$monday = array(); // 几号是周一
// exit($weekStart);
for($i = $iBegin; $i <= $iEnd; $i++){
	$col = PHPExcel_Cell::stringFromColumnIndex($i);
	$objPHPExcel->getActiveSheet()->getStyle($col)->applyFromArray($tdStyle);
	for($j=1; $j <= 3; $j++){
		$objPHPExcel->getActiveSheet()->getStyle($col.$j)->applyFromArray($thStyle);
	}
	// 背景色
	$objPHPExcel->getActiveSheet()->getStyle($col.'2:'.$col.'3')
		->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
	$objPHPExcel->getActiveSheet()->getStyle($col.'2:'.$col.'3')
		->getFill()->getStartColor()->setARGB("FFCCFFFF");
	if($i >= 2 && $day <= $totalDay) {
		// 第N天
		$objPHPExcel->getActiveSheet()->setCellValue($col.'2', $day);
		// 星期N
		$objPHPExcel->getActiveSheet()->setCellValue($col.'3', $week[$weekStart]);
		if('六' == $week[$weekStart]) $saturdayCount++;
		if('日' == $week[$weekStart]) $sundayCount++;
		if('一' == $week[$weekStart]) $monday[] = $day; // 用于判断周一是否迟到
		$weekStart++;
		if($weekStart > 6) $weekStart = 0;
		// 列宽
		$objPHPExcel->getActiveSheet()->getColumnDimension($col)->setWidth(4);
		$day++;
	}
}
// print_r($monday);
// exit;

$objPHPExcel->getActiveSheet()->mergeCells('A1:'.$endCol.'1')->setCellValue('A1', $title);
$objPHPExcel->getActiveSheet()->getStyle('A1')->getFont()->setSize(20);
$objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(30);

$objPHPExcel->getActiveSheet()->mergeCells('A2:A3')->setCellValue('A2', '姓名');
$objPHPExcel->getActiveSheet()->setCellValue('B2', '日期');
$objPHPExcel->getActiveSheet()->setCellValue('B3', '星期');

# tbody
$rowStart = 4;
// foreach ($data as $name => $person) {
foreach ($staff as $s) {
	if(!isset($data[$s['name']])) $data[$s['name']] = array();
	$name = $s['name'];
	$person = $data[$s['name']];

	$rowNext  = $rowStart + 1;
	// 填姓名
	$objPHPExcel->getActiveSheet()->mergeCells('A'.$rowStart.':A'.$rowNext); // 合并姓名格
	$objPHPExcel->getActiveSheet()->setCellValue('A'.$rowStart, $name); // 填姓名

	// 填上午和下午
	$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, '上午');
	$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowNext,  '下午');

	// 每天的考勤
	for($d = 1; $d <= $totalDay+1; $d++){ // +1 的作用：防止前一个单元过长的内容覆盖在后一个空单元格上（不好看）
		if(!isset($person[$d]) || empty($person[$d])) $person[$d] = ' ';
		$col = PHPExcel_Cell::stringFromColumnIndex($d+1); // 每从第3格开始填
		$objPHPExcel->getActiveSheet()->setCellValue($col.$rowStart, $person[$d]);
		$objPHPExcel->getActiveSheet()->setCellValue($col.$rowNext,  $person[$d]);
		// $objPHPExcel->getActiveSheet()->mergeCells($col.$rowStart.':'.$col.$rowNext);
	}
	$rowStart += 2;
}

/**



 */
// tab2:
// goto output;
$runTimeEnd = time();
$runTime = $runTimeEnd - $runTimeStart;
$objPHPExcel->setActiveSheetIndex(2);
foreach ($workTime as $key => $value) {
	foreach ($value as $k => $v) {
		$workTime[$key][$k] = date('H:i',$v);
	}
}
$data = array(
	' ',
	'考勤时间点：',
	'　融科：'.implode(' ',$workTime['中心']),
	'　科大：'.implode(' ',$workTime['科大']),
	'项目部：'.implode(' ',$workTime['项目部']),
	' ',
	'开发调试信息：',
	'内存使用：'.(memory_get_usage(true) / 1024 / 1024).'MB',
	'内存峰值：'.(memory_get_peak_usage(true) / 1024 / 1024).'MB',
	'开始导出：'.date('Y-m-d H:i:s',$runTimeStart),
	'结束导出：'.date('Y-m-d H:i:s',$runTimeEnd),
	'导出用时：'.$runTime.'秒',
	'数据间隔：'.date('Y-m-d H:i:s',$dateStart).'~'.date('Y-m-d H:i:s',$dateEnd),
	'技术支持：root@upall.cn',
);
$rowStart = 0;
$totalData = count($data);
for($i = 0; $i < $totalData; $i++){
	$objPHPExcel->getActiveSheet()->setCellValue('B'.$rowStart, $data[$i]);
	$rowStart++;
}

/**

 */
// output:
// exit;
// 输出
$objPHPExcel->setActiveSheetIndex(0); // 打开文档时默认显示第一张表
header('Content-Type: application/vnd.ms-excel');
header('Content-Disposition: attachment;filename="'.$xlsName.'"');
header('Cache-Control: max-age=0');

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
$objWriter->save('php://output');
exit;