<?php
@ignore_user_abort(true);
@set_time_limit(0);
$runTimeStart = time();//strtotime('2015-02-03');

include('./common.inc.php');
$data = array();
$staff = array();

# 员工信息(以姓名为键名值为补休天数，重名只留最后一个)
$reader = PHPExcel_IOFactory::createReader(PHPExcel_IOFactory::identify($dataFile00));
$PHPExcel = $reader->load($dataFile00);
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$totalRow = $sheet->getHighestRow(); // 取得总行数
$totalCol = $sheet->getHighestColumn(); // 取得总列数
$totalCol = PHPExcel_Cell::columnIndexFromString($totalCol);
$iBegin = PHPExcel_Cell::columnIndexFromString('A')-1;
$iEnd   = $totalCol;
for($row = 2; $row <= $totalRow; $row++){ // 每行
	$name = $sheet->getCellByColumnAndRow(0,$row)->getValue();
	$days = $sheet->getCellByColumnAndRow(1,$row)->getValue();
	$dept = $sheet->getCellByColumnAndRow(2,$row)->getValue();
	$spec = $sheet->getCellByColumnAndRow(3,$row)->getValue();
	if(empty($name) && empty($days)) break;
	$staff[$row]['name'] = $name;
	$staff[$row]['days'] = $days;
	$staff[$row]['dept'] = $dept;
	$staff[$row]['spec'] = $spec;
}
// echo '<meta charset="utf-8" />';
// echo '<pre>';
// print_r($staff);
// echo '</pre>';
// exit;

// 存 科大 数据到内存
$reader = PHPExcel_IOFactory::createReader(PHPExcel_IOFactory::identify($dataFile02));
$PHPExcel = $reader->load($dataFile02);
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$totalRow = $sheet->getHighestRow(); // 取得总行数
$totalCol = $sheet->getHighestColumn(); // 取得总列数
$totalCol = PHPExcel_Cell::columnIndexFromString($totalCol);

$dataStartDate = strtotime($year.'-'.$month.'-1 0:0:0');
$monthDays = date('t',$dataStartDate);
$dataEndDate   = strtotime($year.'-'.$month.'-'.$monthDays.' 23:59:59');
for($row = 2; $row < $totalRow; $row++){
	$name    = $sheet->getCellByColumnAndRow(1,$row)->getValue();
	$datetime= $sheet->getCellByColumnAndRow(3,$row)->getValue();
	if(FALSE === strpos($datetime,' ')){ // 42284.343680556 or 42285.345625 or ...
		date_default_timezone_set('UTC');
		$datetime = ($datetime - 25569) * 3600 * 24;
		$datetime = (int)$datetime;
		$datetime = date('Y-m-d H:i:s',$datetime);
		date_default_timezone_set('PRC');
	}
	$datetime= explode(' ',$datetime);
	$date    = isset($datetime[0])?$datetime[0]:'';
	$record  = isset($datetime[1])?$datetime[1]:'';
	
	$date = strtotime($date);
	if($date >= $dataStartDate && $date <= $dataEndDate){
		$date = date('j',$date);
		$data[$name][$date][] = $record;
	}
}
foreach ($data as $name => $n) {
	foreach ($n as $day => $value) {
		$data[$name][$day] = implode(' ',$value);
	}
}

// 存 中心 数据到内存
$reader = PHPExcel_IOFactory::createReader(PHPExcel_IOFactory::identify($dataFile01));
$PHPExcel = $reader->load($dataFile01);
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$totalRow = $sheet->getHighestRow(); // 取得总行数
$totalCol = $sheet->getHighestColumn(); // 取得总列数
$totalCol = PHPExcel_Cell::columnIndexFromString($totalCol);

$iBegin = PHPExcel_Cell::columnIndexFromString('A')-1;
$iEnd   = $totalCol;
$dataStartDate = strtotime($year.'-'.$month.'-1 0:0:0');
$monthDays = date('t',$dataStartDate);
$dataEndDate   = strtotime($year.'-'.$month.'-'.$monthDays.' 23:59:59');
for($row = 2; $row <= $totalRow; $row++){ // 每行
	$name = $sheet->getCellByColumnAndRow(1,$row)->getValue();
	$date = $sheet->getCellByColumnAndRow(3,$row)->getValue();
	$record=$sheet->getCellByColumnAndRow(4,$row)->getValue();
	$date = strtotime($date);
	if($date >= $dataStartDate && $date <= $dataEndDate){
		$date = date('j',$date);
		$data[$name][$date] = $record;
	}
}

// 存 项目部 数据到内存
$reader = PHPExcel_IOFactory::createReader(PHPExcel_IOFactory::identify($dataFile03));
$PHPExcel = $reader->load($dataFile03);
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$totalRow = $sheet->getHighestRow(); // 取得总行数
$totalCol = $sheet->getHighestColumn(); // 取得总列数
$totalCol = PHPExcel_Cell::columnIndexFromString($totalCol);

$iBegin = PHPExcel_Cell::columnIndexFromString('A')-1;
$iEnd   = $totalCol;
for($row = 2; $row < $totalRow; $row+=4){ // 每行
	$name = $sheet->getCellByColumnAndRow('A',$row)->getValue();
	$name = explode('  ',$name);
	if(!isset($name[1])){
		continue;
	}
	$name = explode(':',$name[1]);
	$name = $name[1];
	
	$day = 1;
	for($c=$iBegin; $c <= $iEnd; $c++){
		// 取源数据中各天的打卡记录
		$record = $sheet->getCellByColumnAndRow($c,($row+2))->getValue();
		$data[$name][$day] = $record;
		$day++;
	}
}


include('createXLS.inc.php');
?>